#include "libelybot_can.h"
#include "fdcan.h"
#include <string.h>


FDCAN_RxHeaderTypeDef fdcan_rx_header1;
uint8_t fdcan1_rdata[24] = {0};


motor_state_t motor_state;
uint8_t motor_read_flag = 0;


uint8_t can_send(FDCAN_HandleTypeDef *hfdcanx, uint32_t id, uint8_t *msg, uint8_t len)
{
    FDCAN_TxHeaderTypeDef TxHeader;
    uint8_t TxData[8] = {0};

    TxHeader.Identifier = id;	//չID
    TxHeader.IdType = FDCAN_EXTENDED_ID; 	//ʹչID
    TxHeader.TxFrameType = FDCAN_DATA_FRAME; //֡
    TxHeader.DataLength = FDCAN_DLC_BYTES_8; //ݳ
    TxHeader.ErrorStateIndicator = FDCAN_ESI_ACTIVE;// ָʾ״̬
    TxHeader.BitRateSwitch = FDCAN_BRS_OFF; //лرգھCAN
    TxHeader.FDFormat = FDCAN_CLASSIC_CAN; //CANʽ
    TxHeader.TxEventFifoControl = FDCAN_NO_TX_EVENTS;// ÷¼FIFO
    TxHeader.MessageMarker = 0; //Ϣ


    //ݵͻ
    for(int i = 0; i < len; i++)
    {
        TxData[i] = msg[i];
    }

    // CANָ
    if(HAL_FDCAN_AddMessageToTxFifoQ(hfdcanx, &TxHeader, TxData) != HAL_OK)
    {
        // ʧܴ
        Error_Handler();
        return 1; // طֵԱʾʧ
    }
    return 0; // ͳɹ
}


void fdcan_filter_init(FDCAN_HandleTypeDef *fdcanHandle)
{
    if (HAL_FDCAN_ConfigGlobalFilter(fdcanHandle, FDCAN_ACCEPT_IN_RX_FIFO0, FDCAN_ACCEPT_IN_RX_FIFO0, FDCAN_FILTER_REMOTE, FDCAN_FILTER_REMOTE) != HAL_OK)
    {
        Error_Handler();
    }

    if (HAL_FDCAN_ActivateNotification(fdcanHandle, FDCAN_IT_RX_FIFO0_NEW_MESSAGE | FDCAN_IT_TX_FIFO_EMPTY, 0) != HAL_OK)
    {
        Error_Handler();
    }
    HAL_FDCAN_ConfigTxDelayCompensation(fdcanHandle, fdcanHandle->Init.DataPrescaler * fdcanHandle->Init.DataTimeSeg1, 0);
    HAL_FDCAN_EnableTxDelayCompensation(fdcanHandle);

    if (HAL_FDCAN_Start(fdcanHandle) != HAL_OK)
    {
        Error_Handler();
    }

    //HAL_FDCAN_Start(fdcanHandle);
}


/**
 * @brief λÿ
 * @param id  ID
 * @param pos λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param أλ0.01 NM torque = 110 ʾΪ 1.1NM
 */
void motor_control_Pos(FDCAN_HandleTypeDef *hfdcanx, uint8_t id, int32_t pos, int16_t tqe)
{
    uint8_t tdata[8] = {0x07, 0x07, 0x0A, 0x05, 0x00, 0x00, 0x80, 0x00};

    *(int16_t *)&tdata[2] = pos;
    *(int16_t *)&tdata[6] = tqe;

    can_send(hfdcanx, 0x8000 | id, tdata, 8);
}


/**
 * @brief ٶȿ
 * @param id ID
 * @param vel ٶȣλ 0.00025 ת/룬 val = 1000 ʾ 0.25 ת/
 * @param tqe أλ0.01 NM torque = 110 ʾΪ 1.1NM
 */
void motor_control_Vel(FDCAN_HandleTypeDef *hfdcanx, uint8_t id, int16_t vel, int16_t tqe)
{
    uint8_t tdata[8] = {0x07, 0x07, 0x00, 0x80, 0x20, 0x00, 0x80, 0x00};

    *(int16_t *)&tdata[4] = vel;
    *(int16_t *)&tdata[6] = tqe;

    can_send(hfdcanx, 0x8000 | id, tdata, 8);
}


/**
 * @brief ģʽ
 * @param id ID
 * @param tqe أλ0.01 NM torque = 110 ʾΪ 1.1NM
 */
void motor_control_tqe(FDCAN_HandleTypeDef *hfdcanx, uint8_t id, int32_t tqe)
{
    uint8_t tdata[8] = {0x05, 0x13, 0x00, 0x80, 0x20, 0x00, 0x80, 0x00};

    *(int16_t *)&tdata[2] = tqe;

    can_send(hfdcanx, 0x8000 | id, tdata, 4);
}


/**
 * @brief λ-ٶ-ǰ()ƣint16
 * @param id  ID
 * @param pos λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param val ٶȣλ 0.00025 ת/룬 val = 1000 ʾ 0.25 ת/
 * @param tqe أλ0.01 NM torque = 110 ʾΪ 1.1NM
 */
void motor_control_pos_val_tqe(FDCAN_HandleTypeDef *hfdcanx, uint8_t id, int16_t pos, int16_t val, int16_t tqe)
{
    static uint8_t tdata[8] = {0x07, 0x35, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

    *(int16_t *)&tdata[2] = val;
    *(int16_t *)&tdata[4] = tqe;
    *(int16_t *)&tdata[6] = pos;

    can_send(hfdcanx, 0x8000 | id, tdata, 8);
}


/**
 * @brief ǰλΪλ(ָֻ RAM ޸ģ `conf write` ָ浽 flash )
 * @param id ID
 */
void rezero_pos(FDCAN_HandleTypeDef *hfdcanx, uint8_t id)
{
    uint8_t tdata[] = {0x40, 0x01, 0x04, 0x64, 0x20, 0x63, 0x0a};

    can_send(hfdcanx, 0x8000 | id, tdata, sizeof(tdata));
    HAL_Delay(1000);  // ʱ1s

    conf_write(hfdcanx, id);  // 
}


/**
 * @brief  RAM ñ浽 flash (ʹôָϵ)
 * @param id ID
 */
void conf_write(FDCAN_HandleTypeDef *hfdcanx, uint8_t id)
{
    uint8_t tdata[] = {0x05, 0xb3, 0x02, 0x00, 0x00};

    can_send(hfdcanx, 0x8000 | id, tdata, sizeof(tdata));
}


/**
 * @brief ڷصλáٶȡ(ݸʽʹ 0x170x01 ָȡĸʽһ)
 * @param id ID
 * @param t ڣλms
 */
void timed_return_motor_status(FDCAN_HandleTypeDef *hfdcanx, uint8_t id, int16_t t_ms)
{
    uint8_t tdata[] = {0x05, 0xb4, 0x02, 0x00, 0x00};

    *(int16_t *)&tdata[3] = t_ms;

    can_send(hfdcanx, 0x8000 | id, tdata, sizeof(tdata));
}


/**
 * @brief ֹͣע⣺õֹͣλЧ
 * @param fdcanHandle &hfdcanx
 * @param motor id ID
 */
void set_motor_stop(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id)
{
    static uint8_t cmd[] = {0x01, 0x00, 0x00};

    can_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ɲ
 * @param fdcanHandle &hfdcanx
 * @param motor id ID
 */
void set_motor_brake(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id)
{
    static uint8_t cmd[] = {0x01, 0x00, 0x0f};

    can_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ȡλáٶȡָ
 * @param id ID
 */
void motor_read(FDCAN_HandleTypeDef *hfdcanx, uint8_t id)
{
    static uint8_t tdata[8] = {0x17, 0x01};

    can_send(hfdcanx, 0x8000 | id, tdata, sizeof(tdata));
}


static uint8_t Fdcan_Dlc_To_Len(uint32_t dlc)
{
    uint8_t len = 0;
    uint8_t tab_dlc_to_len[] = {12, 16, 20, 24, 32, 48, 64};

    if (dlc <= FDCAN_DLC_BYTES_8)
    {
        len = dlc >> 16;
    }
    else
    {
        len = tab_dlc_to_len[(dlc >> 16) - 9];
    }

    return len;
}


void HAL_FDCAN_RxFifo0Callback(FDCAN_HandleTypeDef *hfdcan, uint32_t RxFifo0ITs)  // FDCAN FIFO 0 ص
{
    uint8_t len = 0;
    if(hfdcan->Instance == FDCAN1 || hfdcan->Instance == FDCAN2 || hfdcan->Instance == FDCAN3)  // ͲĸcanͨĶ
    {
        HAL_FDCAN_GetRxMessage(hfdcan, FDCAN_RX_FIFO0, &fdcan_rx_header1, fdcan1_rdata);
        if (fdcan_rx_header1.DataLength != 0)
        {
            len = Fdcan_Dlc_To_Len(fdcan_rx_header1.DataLength);
            motor_state.motor.id = fdcan_rx_header1.Identifier;  // ȡ id

            memcpy(&motor_state.data[4], &fdcan1_rdata[2], len - 2);  // ȡ״̬ݣЭ
			
//            motor_state.motor.position = *(int16_t *)&fdcan1_rdata[2];  // ֱmemcpyЧͬ
//            motor_state.motor.velocity = *(int16_t *)&fdcan1_rdata[4];
//            motor_state.motor.torque = *(int16_t *)&fdcan1_rdata[6];
            motor_read_flag = 1;
        }
    }
}

